﻿using System;
using System.Collections.Generic;
using System.Threading;
using System.Threading.Tasks;

namespace ConsoleApplication1
{
    class Program
    {
        static void Main(string[] args)
        {
            // 동기 방식으로 실행: 8초 소요
            //int result3 = Method3();
            //int result5 = Method5();

            //Console.WriteLine(result3 + result5);

            // 스레드를 병렬로 실행: 5초 소요
            //Dictionary<string, int> dict = new Dictionary<string, int>();

            //Thread t3 = new Thread((result) =>
            //{
            //    Thread.Sleep(3000);
            //    dict.Add("t3Result", 3);
            //});

            //Thread t5 = new Thread((result) =>
            //{
            //    Thread.Sleep(5000);
            //    dict.Add("t5Result", 5);
            //});

            //t3.Start(dict);
            //t5.Start(dict);

            //t3.Join();
            //t5.Join();

            //Console.WriteLine(dict["t3Result"] + dict["t5Result"]);

            // Task를 이용해 병렬로 처리
            //var task3 = Method3Async();
            //var task5 = Method5Async();

            // task3 작업과 task5 작업이 완료될 때까지 현재 스레드를 대기
            //Task.WaitAll(task3, task5); 

            //Console.WriteLine(task3.Result + task5.Result);

            // await를 이용해 병렬로 비동기 호출: 5초 소요
            DoAsyncTask();

            Console.ReadLine();
        }

        private static async void DoAsyncTask()
        {
            var task3 = Method3Async();
            var task5 = Method5Async();

            await Task.WhenAll(task3, task5);

            Console.WriteLine(task3.Result + task5.Result);
        }

        private static Task<int> Method3Async()
        {
            return Task.Factory.StartNew(() =>
            {
                Thread.Sleep(3000);
                return 3;
            });
        }

        private static Task<int> Method5Async()
        {
            return Task.Factory.StartNew(() =>
            {
                Thread.Sleep(5000);
                return 5;
            });
        }

        private static int Method3()
        {
            Thread.Sleep(3000); // 3초가 걸리는 작업을 대신해서 Sleep처리
            return 3;
        }

        private static int Method5()
        {
            Thread.Sleep(5000); // 5초가 걸리는 작업을 대신해서 Sleep처리
            return 5;
        }
    }
}
